<?php
namespace Modules\Relatorio\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;

class ComparativoCotacaoVolumeCompraController extends \Zeedhi\Framework\Controller\Report {
  
    protected $birtStrategy;

    public function __construct(ReportService $reportService, $birtStrategy){
        parent::__construct($reportService);
        $this->birtStrategy = $birtStrategy;
    }
 
    protected $reportMapping = array (
        'comparativoNfCot' => array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "CDREGIAO"    => "P_CDREGIAO",
              "CDCOMPRADOR" => "P_CDCOMPRADOR",
              "CDPRODINI"   => "P_CDPRODINI",
              "CDPRODFIN"   => "P_CDPRODFIM",
              "DTINICIAL"   => "P_DTINI",
              "DTFINAL"     => "P_DTFIN",
              "NRARVOREPROD"=> "P_NRARVOREPROD",
              "IDTPCOMPARA" => "P_IDTPCOMPARA",
              "DSTPARVPROD" => "P_DSTPARVPROD",
              "IDCNPJRAIZ"  => "P_IDCNPJRAIZ",
              "IDREGIAO"    => "P_IDREGIAO"
            )
        )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $this->birtStrategy->setReportFormat($row['QR2TYPE']);
    }

}