<?php
namespace Contabilidade\Repositories;

use \Setforms2\Shared\Registry;

class Contopectbl extends \Doctrine\ORM\EntityRepository
{

    public static function getContaInicialFinal(){
        $sql = "SELECT MAX(CDCONTCTBL) CDCONTFIN, MIN(CDCONTCTBL) CDCONTINI
                  FROM CONTCTBL
                 WHERE IDCONTCCUS <> 'R'
                 ORDER BY 1 ASC";
        try {
            return Registry::getEntityManager()->getConnection()->fetchAll($sql);
        } catch (\Exception $e) {
            throw $e;
        }
    }

	public function vdPeriodoLancamento($cdempresa, $data){

        $sql = "SELECT 1 
                FROM CONTOPECTBL 
                WHERE :P_CDEMPRESA = CDEMPRESA AND
                      :P_DTLANCAMENTO BETWEEN DTINICCTBL AND DTFINACCTBL";



		$params = array(
			            'P_CDEMPRESA' => $cdempresa,
			            'P_DTLANCAMENTO'    => $data,
                       );
             
        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql,$params);
        } catch(\Exception $e){
            throw $e;
        }
	}

    public function verificaDataLancamento($cdempresa, $data, $nrorg){

        $sql = "SELECT CDEMPRESA
				  FROM CONTOPECTBL
				 WHERE DTINICLANC <= :DTEMIS
                   AND DTFINALANC >= :DTEMIS
                   AND CDEMPRESA = :EMPRESA
                   AND NRORG = :NRORG";


        $params = array(
            'EMPRESA' => $cdempresa,
            'DTEMIS'    => $data,
            'NRORG'     => $nrorg
        );

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql,$params);
        } catch(\Exception $e){
            throw $e;
        }
    }

    public static  function retornaPeriodoContabil($cdempresa, $nrorg){
        $sql = "SELECT DTINICCTBL, DTFINACCTBL
                  FROM CONTOPECTBL
                 WHERE :P_CDEMPRESA = CDEMPRESA
                   AND :P_NRORG = NRORG";

        $params = array(
            'P_CDEMPRESA'    => $cdempresa,
            'P_NRORG'        => $nrorg,
        );

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql,$params);
        } catch(\Exception $e){
            throw $e;
        }
    }





}