<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;


class GpeSolicitacao extends \Doctrine\ORM\EntityRepository {

    public function getInfoFase($nrorg, $nrsolicitacao) {
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();

        $sql = <<<SQL
SELECT
    S.NRORG,
    S.NRSOLICITACAO,
    S.NRTIPOSOLICITACAO,
    TS.NMTIPOSOLICITACAO,
    S.NRVINCULOM,
    VM.NMVINCULOM,
    T.NRMODELOAPROVSOLI,
    FASE_TRAM_ATUAL.NRFASETRAMSOLI NRFASETRAMSOLI_ATUAL,
    FASE_TRAM_ATUAL.IDAPROVADO IDAPROVADO_ATUAL,
    CASE
        WHEN FASE_SEGUINTE.NRFASEAPROVSOLI IS NOT NULL
            AND (FASE_TRAM_ATUAL.IDAPROVADO = 'S' OR (FASE_TRAM_ATUAL.IDAPROVADO = 'N' AND FASE_ATUAL.IDFASEOBRIGATORIA = 'N') OR FASE_TRAM_ATUAL.NRFASETRAMSOLI IS NULL)
            AND S.IDAPROVACAOSEC NOT IN ('R', 'A') THEN 'S'
        ELSE 'N'
    END FASE_ATUAL_VALIDA_APROVACAO,
    FASE_TRAM_ATUAL.DSOBSERVACAO DSOBSERVACAO_ATUAL,
    FASE_SEGUINTE.NRFASEAPROVSOLI NRFASEAPROVSOLI_SEGUINTE,
    FASE_SEGUINTE.NRORDEM NRORDEM_SEGUINTE,
    FASE_SEGUINTE.IDFASEOBRIGATORIA IDFASEOBRIGATORIA_SEGUINTE,
    CASE
        WHEN FASE_SEGUINTE.NRFASEAPROVSOLI IS NULL THEN 'N'
        ELSE 'S'
    END EXISTE_FASE_SEGUINTE,
    CASE
        WHEN FASE_SEGUINTE.NRFASEAPROVSOLI = ULTIMA_FASE.NRFASEAPROVSOLI THEN 'S'
        ELSE 'N'
    END FASE_ATUAL_EH_ULTIMA,
    EMAILS_APROV_FASE_SEGUINTE.DSEMAILSOPER DSEMAILSOPER_APROV_FASE_SEGUINTE
FROM GPE_SOLICITACAO S
JOIN GPE_VINCULOM VM ON VM.NRORG = S.NRORG
    AND VM.NRVINCULOM = S.NRVINCULOM
JOIN GPE_TIPOSOLICITACAO TS ON TS.NRTIPOSOLICITACAO = S.NRTIPOSOLICITACAO
JOIN GPE_PERFACESTIPOSOLI T ON T.NRORG = S.NRORG
    AND T.NRTIPOSOLICITACAO = S.NRTIPOSOLICITACAO
JOIN GPE_MODELOAPROVSOLI M ON M.NRORG = S.NRORG
    AND M.NRMODELOAPROVSOLI = T.NRMODELOAPROVSOLI
LEFT JOIN GPE_FASETRAMSOLI FASE_TRAM_ATUAL ON FASE_TRAM_ATUAL.NRORG = S.NRORG
    AND FASE_TRAM_ATUAL.NRSOLICITACAO = S.NRSOLICITACAO
    AND FASE_TRAM_ATUAL.NRFASEAPROVSOLI = (
        SELECT F2.NRFASEAPROVSOLI
        FROM GPE_FASETRAMSOLI F2
        LEFT JOIN GPE_FASEAPROVSOLI FA2 ON FA2.NRORG = F2.NRORG
            AND FA2.NRFASEAPROVSOLI = F2.NRFASEAPROVSOLI
        WHERE F2.NRORG = FASE_TRAM_ATUAL.NRORG
            AND F2.NRSOLICITACAO = FASE_TRAM_ATUAL.NRSOLICITACAO
        ORDER BY FA2.NRORDEM DESC
        FETCH FIRST ROW ONLY
    )
LEFT JOIN GPE_FASEAPROVSOLI FASE_ATUAL ON FASE_ATUAL.NRORG = S.NRORG
    AND FASE_ATUAL.NRFASEAPROVSOLI = FASE_TRAM_ATUAL.NRFASEAPROVSOLI
LEFT JOIN GPE_FASEAPROVSOLI FASE_SEGUINTE ON FASE_SEGUINTE.NRORG = S.NRORG
    AND FASE_SEGUINTE.NRMODELOAPROVSOLI = T.NRMODELOAPROVSOLI
    AND FASE_SEGUINTE.NRORDEM = (
        SELECT MIN(NRORDEM)
        FROM GPE_FASEAPROVSOLI
        WHERE NRORG = FASE_SEGUINTE.NRORG
            AND NRMODELOAPROVSOLI = FASE_SEGUINTE.NRMODELOAPROVSOLI
            AND NRFASEAPROVSOLI > NVL(FASE_TRAM_ATUAL.NRFASEAPROVSOLI, -1)
    )
LEFT JOIN GPE_FASEAPROVSOLI ULTIMA_FASE ON ULTIMA_FASE.NRORG = S.NRORG
    AND ULTIMA_FASE.NRMODELOAPROVSOLI = T.NRMODELOAPROVSOLI
    AND ULTIMA_FASE.NRORDEM = (
        SELECT MAX(NRORDEM)
        FROM GPE_FASEAPROVSOLI
        WHERE NRORG = ULTIMA_FASE.NRORG
            AND NRMODELOAPROVSOLI = ULTIMA_FASE.NRMODELOAPROVSOLI
    )
LEFT JOIN (
    SELECT
        FAS.NRFASEAPROVSOLI,
        LISTAGG(DISTINCT OP.DSEMAILOPER, ',') WITHIN GROUP (ORDER BY OP.DSEMAILOPER) DSEMAILSOPER
    FROM GPE_FASEAPROVSOLI FAS
    JOIN PERFACESSPARC PAP ON PAP.NRORG = FAS.NRORG
        AND INSTR(',' || FAS.DSNRPERFILACESSO || ',', ',' || PAP.NRPERFILACESSO || ',') > 0
    JOIN OPERADOR OP ON OP.NRORG = PAP.NRORG
        AND OP.NRPARCNEGOCIO = PAP.NRPARCNEGOCIO
    
    /* Operadores responsaveis por estruturas */
    LEFT JOIN ESTRUTURAH EH ON EH.NRORG = OP.NRORG
        AND EH.DTMESCOMPETENC = (
            SELECT DTMESCOMPETENC
            FROM ESTRUTURAH
            WHERE NRORG = EH.NRORG
                AND NRESTRUTURAM = EH.NRESTRUTURAM
            ORDER BY DTMESCOMPETENC DESC
            FETCH FIRST ROW ONLY
        )
        AND (
            INSTR(',' || EH.NRPARCRESPINF || ',', ',' || OP.NRPARCNEGOCIO || ',') > 0 OR
            INSTR(',' || EH.NRPARCRESPINFADIC || ',', ',' || OP.NRPARCNEGOCIO || ',') > 0
        )
        
    /* Operadores que sao responsaveis por estruturas hierarquicamente superiores - ou diretamente - a gerencial do vinculo */
    JOIN GPE_VINCULOH VH ON VH.NRORG = FAS.NRORG
        AND VH.NRVINCULOM = (
            SELECT NRVINCULOM
            FROM GPE_SOLICITACAO
            WHERE NRORG = VH.NRORG
                AND NRSOLICITACAO = :P_NRSOLICITACAO
        )
        AND VH.DTMESCOMPETENC = (
            SELECT DTMESCOMPETENC
            FROM GPE_VINCULOH
            WHERE NRORG = VH.NRORG
                AND NRVINCULOM = VH.NRVINCULOM
            ORDER BY DTMESCOMPETENC DESC
            FETCH FIRST ROW ONLY
        )
        /* A estrutura gerencial do vinculo associado a solicitacao deve ter como responsavel direto o operador
        ou de estar hierarquicamente conectada a alguma na qual o operador eh reponsavel */
        AND (
            VH.NRESTRUTGEREN IN (
                SELECT
                    HIER.NRESTRUTURAMREL NRESTRUTURAM
                FROM HIERARQUIAORG HIER
                WHERE HIER.NRORG = :P_NRORG
                START WITH
                    HIER.NRESTRUTURAMSUP = EH.NRESTRUTURAM
                CONNECT BY NOCYCLE
                    PRIOR HIER.NRESTRUTURAMREL = HIER.NRESTRUTURAMSUP
                    AND PRIOR HIER.NRORG = HIER.NRORG
            ) OR VH.NRESTRUTGEREN = EH.NRESTRUTURAM
        )
    WHERE FAS.NRORG = :P_NRORG
    GROUP BY FAS.NRFASEAPROVSOLI
) EMAILS_APROV_FASE_SEGUINTE ON EMAILS_APROV_FASE_SEGUINTE.NRFASEAPROVSOLI = FASE_SEGUINTE.NRFASEAPROVSOLI
WHERE S.NRORG = :P_NRORG
    AND S.NRSOLICITACAO = :P_NRSOLICITACAO
SQL;

        $params = array(
            'P_NRORG' => $nrorg,
            'P_NRSOLICITACAO' => $nrsolicitacao
        );

        return $db->fetchAssoc($sql, $params);
    }
}